/* file: quality_metric_single_beta_batch.cpp */
/*******************************************************************************
* Copyright 2014-2021 Intel Corporation
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*******************************************************************************/

/* DO NOT EDIT THIS FILE - it is machine generated */
#include <jni.h>
#include "daal.h"
#include "com_intel_daal_algorithms_linear_regression_quality_metric_SingleBetaBatch.h"
#include "com/intel/daal/common_helpers.h"

USING_COMMON_NAMESPACES();
using namespace daal::algorithms::linear_regression::quality_metric;
using namespace daal::algorithms::linear_regression::quality_metric::single_beta;

/*
* Class:     com_intel_daal_algorithms_linear_regression_quality_metric_SingleBetaBatch
* Method:    cInit
* Signature: (II)J
*/
JNIEXPORT jlong JNICALL Java_com_intel_daal_algorithms_linear_1regression_quality_1metric_SingleBetaBatch_cInit(JNIEnv *, jobject, jint prec,
                                                                                                                jint method)
{
    return jniBatch<single_beta::Method, Batch, defaultDense>::newObj(prec, method);
}

/*
* Class:     com_intel_daal_algorithms_linear_regression_quality_metric_SingleBetaBatch
* Method:    cSetResult
* Signature: (JIIJ)V
*/
JNIEXPORT void JNICALL Java_com_intel_daal_algorithms_linear_1regression_quality_1metric_SingleBetaBatch_cSetResult(JNIEnv *, jobject, jlong algAddr,
                                                                                                                    jint prec, jint method,
                                                                                                                    jlong resultAddr)
{
    jniBatch<single_beta::Method, Batch, defaultDense>::setResult<single_beta::Result>(prec, method, algAddr, resultAddr);
}

/*
* Class:     com_intel_daal_algorithms_linear_regression_quality_metric_SingleBetaBatch
* Method:    cInitParameter
* Signature: (JII)J
*/
JNIEXPORT jlong JNICALL Java_com_intel_daal_algorithms_linear_1regression_quality_1metric_SingleBetaBatch_cInitParameter(JNIEnv *, jobject,
                                                                                                                         jlong algAddr, jint prec,
                                                                                                                         jint method)
{
    return jniBatch<single_beta::Method, Batch, defaultDense>::getParameter(prec, method, algAddr);
}

/*
* Class:     com_intel_daal_algorithms_linear_regression_quality_metric_SingleBetaBatch
* Method:    cGetInput
* Signature: (JII)J
*/
JNIEXPORT jlong JNICALL Java_com_intel_daal_algorithms_linear_1regression_quality_1metric_SingleBetaBatch_cGetInput(JNIEnv *, jobject, jlong algAddr,
                                                                                                                    jint prec, jint method)
{
    return jniBatch<single_beta::Method, Batch, defaultDense>::getInput(prec, method, algAddr);
}

/*
* Class:     com_intel_daal_algorithms_linear_regression_quality_metric_SingleBetaBatch
* Method:    cGetResult
* Signature: (JII)J
*/
JNIEXPORT jlong JNICALL Java_com_intel_daal_algorithms_linear_1regression_quality_1metric_SingleBetaBatch_cGetResult(JNIEnv *, jobject, jlong algAddr,
                                                                                                                     jint prec, jint method)
{
    return jniBatch<single_beta::Method, Batch, defaultDense>::getResult(prec, method, algAddr);
}

/*
* Class:     com_intel_daal_algorithms_linear_regression_quality_metric_SingleBetaBatch
* Method:    cClone
* Signature: (JII)J
*/
JNIEXPORT jlong JNICALL Java_com_intel_daal_algorithms_linear_1regression_quality_1metric_SingleBetaBatch_cClone(JNIEnv *, jobject, jlong algAddr,
                                                                                                                 jint prec, jint method)
{
    return jniBatch<single_beta::Method, Batch, defaultDense>::getClone(prec, method, algAddr);
}
